from sys import argv
from os import walk
from getopt import getopt, GetoptError


def version():

    print("+-------------------------------------------------------------------------------+")
    print("| pywalk3. Copyright (C) 2017 ShRP, Contact: liberserpentis@gmail.com            |")
    print("| Version: 1.0                                                                  |")
    print("|                                                                               |")
    print("| This program comes with ABSOLUTELY NO WARRANTY; for details type `show w`.    |")
    print("| This is free software, and you are welcome to redistribute it                 |")
    print("| under certain conditions; type `show c` for details.                          |")
    print("+-------------------------------------------------------------------------------+")


def usage():

    print("Usage: {0} <options>".format(argv[0]))

    print("\nOptions:")
    print("  -h: --help                           Print usage and exit")
    print("  -V: --version                        Print version information and exit")
    print("  -d: --directory                      Directory to traverse")


def pywalk3(directory):

    try:
        for (path, dirs, files) in walk(directory):
            depth_from_root = len(path.split("/"))
            print("_" * (depth_from_root * 4 + 6) + "(" + path.split("/")[-1] + ")")
            for file in files:
                print("_" * (depth_from_root * 4 + 8) + "(" + file + ")")

    except (KeyboardInterrupt, SystemExit):
        pass


def main():

    directory = ""

    try:
        opts, args = getopt(argv[1:], "hVd:", ["help", "version", "directory="])

    except GetoptError: usage()

    else:
        for opt, arg in opts:
            if opt in ("-h", "--help"): usage(); exit(1)
            if opt in ("-V", "--version"): version(); exit(1)
            if opt in ("-d", "--directory"): directory = arg

        if directory: pywalk3(directory)

        else:
            usage()

if __name__ == "__main__":
        main()
